commit d2434e21eea6198bc9320bfe13f817559a36ac62
Author: jklowden <jklowden>
Date:   Sat Jun 6 01:42:28 2009 +0000

    Applied patch from Andrew Victor ML 24 November 2008 "CTLib implementation handles NVARCHAR strings as VARCHAR"

diff --git a/ChangeLog b/ChangeLog
index 9b60039..eac2964 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Fri Jun  5 21:36:29 EDT 2009	JK Lowden <jklowden@freetds.org>
+	* src/ctlib/cs.c src/ctlib/ct.c
+	* src/tds/convert.c src/tds/data.c
+	- Applied patch from Andrew Victor ML 24 November 2008
+	- "CTLib implementation handles NVARCHAR strings as VARCHAR"
+
 Thu Jun  4 07:39:49 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* doc/api_status.txt: updated
 
@@ -1605,4 +1611,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2803 2009/06/04 05:39:56 freddy77 Exp $
+$Id: ChangeLog,v 1.2804 2009/06/06 01:42:28 jklowden Exp $
diff --git a/src/ctlib/cs.c b/src/ctlib/cs.c
index 3646016..ecbb332 100644
--- a/src/ctlib/cs.c
+++ b/src/ctlib/cs.c
@@ -50,7 +50,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: cs.c,v 1.70 2009/05/03 19:32:57 jklowden Exp $");
+TDS_RCSID(var, "$Id: cs.c,v 1.71 2009/06/06 01:42:29 jklowden Exp $");
 
 static int _cs_datatype_length(int dtype);
 static CS_INT cs_diag_storemsg(CS_CONTEXT *context, CS_CLIENTMSG *message);
@@ -601,6 +601,7 @@ cs_convert(CS_CONTEXT * ctx, CS_DATAFMT * srcfmt, CS_VOID * srcdata, CS_DATAFMT
 
 		case SYBCHAR:
 		case SYBVARCHAR:
+		case SYBNVARCHAR:
 		case SYBTEXT:
 			tdsdump_log(TDS_DBG_FUNC, "cs_convert() desttype = character\n");
 
@@ -812,6 +813,7 @@ cs_convert(CS_CONTEXT * ctx, CS_DATAFMT * srcfmt, CS_VOID * srcdata, CS_DATAFMT
 		break;
 	case SYBCHAR:
 	case SYBVARCHAR:
+	case SYBNVARCHAR:
 	case SYBTEXT:
 		if (len > destlen) {
 			fprintf(stderr, "error_handler: Data-conversion resulted in overflow.\n");
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index def81f3..f4e8b6b 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.189 2009/05/28 16:23:31 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.190 2009/06/06 01:42:29 jklowden Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -2016,6 +2016,9 @@ _ct_get_client_type(int datatype, int usertype, int size)
 			return CS_UNICHAR_TYPE;
 		return CS_CHAR_TYPE;
 		break;
+	case SYBNVARCHAR:
+		return CS_UNICHAR_TYPE;
+		break;
 	}
 
 	return CS_FAIL;
@@ -4034,7 +4037,10 @@ paraminfoalloc(TDSSOCKET * tds, CS_PARAM * first_param)
 				return NULL;
 			pcol->on_server.column_size = pcol->column_size = p->maxlen;
 			pcol->column_cur_size = temp_datalen;
-			if (temp_datalen > 0 && temp_datalen > p->maxlen)
+			if (p->maxlen == 0 && pcol->column_type == SYBNVARCHAR) {
+				pcol->on_server.column_size = pcol->column_size = temp_datalen*2;
+			}
+			else if (temp_datalen > 0 && temp_datalen > p->maxlen)
 				pcol->on_server.column_size = pcol->column_size = temp_datalen;
 		} else {
 			pcol->column_cur_size = pcol->column_size;
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 2c0dad4..0cdb5fa 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.189 2009/05/21 16:39:38 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.190 2009/06/06 01:42:29 jklowden Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -340,6 +340,7 @@ tds_convert_char(int srctype, const TDS_CHAR * src, TDS_UINT srclen, int desttyp
 		return srclen;
 
 	case CASE_ALL_CHAR:
+	case SYBNVARCHAR:		/* CHAR return as Unicode */
 		cr->c = (TDS_CHAR *) malloc(srclen + 1);
 		test_alloc(cr->c);
 		memcpy(cr->c, src, srclen);
diff --git a/src/tds/data.c b/src/tds/data.c
index 3c81ff5..042337b 100644
--- a/src/tds/data.c
+++ b/src/tds/data.c
@@ -35,7 +35,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: data.c,v 1.19 2008/09/17 12:16:08 freddy77 Exp $");
+TDS_RCSID(var, "$Id: data.c,v 1.20 2009/06/06 01:42:29 jklowden Exp $");
 
 #if !ENABLE_EXTRA_CHECKS
 static int tds_get_cardinal_type(int datatype);
@@ -85,6 +85,9 @@ tds_set_param_type(TDSSOCKET * tds, TDSCOLUMN * curcol, TDS_SERVER_TYPE type)
 		case SYBBINARY:
 			type = XSYBBINARY;
 			break;
+		case SYBNVARCHAR:
+			type = XSYBNVARCHAR;
+			break;
 			/* avoid warning on other types */
 		default:
 			break;
@@ -152,6 +155,7 @@ tds_get_cardinal_type(int datatype)
 	case SYBNTEXT:
 		return SYBTEXT;
 	case XSYBNVARCHAR:
+		return SYBNVARCHAR;
 	case XSYBVARCHAR:
 		return SYBVARCHAR;
 	case XSYBNCHAR:

